#!/usr/bin/env python
#
#       Author:	Wolter Hellmund
#       Email:	wolterh6@gmail.com
#       --------------------------------------
#       Configuration (gconf) handler for Fileorganizer
#       --------------------------------------
#       Creative Commons

import gconf
import os

default_ops = {
	'dir':		os.getenv ('HOME')+'/Music/',
	'folder':	'$artist/$album/',
	'file':		'$artist - $title',
	'digits':	2
}

class FileorganizerConf ():

	def __init__(self):
		self.path = '/apps/rhythmbox/plugins/fileorganizer/'
		self.client = gconf.client_get_default ()
		self.set_defaults ()

	# Set default values
	def set_defaults (self):
		for key, val in default_ops.items ():
			keypath = self.path+key
			if self.client.get_without_default (keypath) == None:
				if isinstance(val, bool):
					self.client.set_bool(keypath, val)
				elif isinstance(val, int):
					self.client.set_int(keypath, val)
				elif isinstance(val, float):
					self.client.set_float(keypath, val)
				elif isinstance(val, str):
					self.client.set_string(keypath, val)
				else:
					print 'Datatype %s is not supported' % type(val)

	# Request value
	def get_val (self,key):
		keypath = self.path+key
		if key not in default_ops:
			print 'Invalid key requested'
			return
		return self.client.get (keypath)
