import rhythmdb, rb
import gobject, gtk
import tools, fileops
from configurator import FileorganizerConf

ui_str = """
<ui>
  <popup name="BrowserSourceViewPopup">
    <placeholder name="PluginPlaceholder">
      <menuitem name="FileorganizerPopup" action="OrganizeSelection"/>
    </placeholder>
  </popup>

  <popup name="PlaylistViewPopup">
    <placeholder name="PluginPlaceholder">
      <menuitem name="FileorganizerPopup" action="OrganizeSelection"/>
    </placeholder>
  </popup>

  <popup name="QueuePlaylistViewPopup">
    <placeholder name="PluginPlaceholder">
      <menuitem name="FileorganizerPopup" action="OrganizeSelection"/>
    </placeholder>
  </popup>

  <popup name="PodcastViewPopup">
    <placeholder name="PluginPlaceholder">
      <menuitem name="FileorganizerPopup" action="OrganizeSelection"/>
    </placeholder>
  </popup>
</ui>
"""

class Fileorganizer(rb.Plugin):

	def __init__(self):
		rb.Plugin.__init__(self)

	# Rhythmbox standard Activate method
	def activate (self, shell):
		self.db = shell.get_player().props.db
		self.configurator = FileorganizerConf ()
		self.menu_build (shell)

	# Rhythmbox standard Deactivate method
	def deactivate(self, shell):
		uim = shell.get_ui_manager()
		uim.remove_ui (self.ui_id)
		uim.remove_action_group (self.action_group)
		self.action_group = None
		self.action = None

	# FUNCTIONS
	# Build menu option
	def menu_build (self, shell):
		self.action = gtk.Action('OrganizeSelection', _('Organize selection'),
					 _('Organize the selected music files'),
					 'fileorganizer')
		self.activate_id = self.action.connect('activate', self.organize_selection, shell)
		
		self.action_group = gtk.ActionGroup('FileorganizerActions')
		self.action_group.add_action(self.action)
		
		uim = shell.get_ui_manager ()
		uim.insert_action_group(self.action_group, 0)
		self.ui_id = uim.add_ui_from_string(ui_str)
		uim.ensure_update()

	# Organize selection
	def organize_selection (self, action, shell):
		source = shell.get_property("selected_source")
		entry = rb.Source.get_entry_view(source)
		selection = entry.get_selected_entries()
		self.organize (selection)

	# Organize array of files
	def organize (self, filelist):
		if filelist != []:
			for item in filelist:
				item = fileops.Musicfile (self, item)
				item.relocate ()
